Subject: Re: [PATCH v2] macvlan: Support creating macvtaps from macvlans

From: Vlad Yasevich <[email-masked]>
Date: Wed, 04 Dec 2013 08:59:21 -0500

On 12/03/2013 02:47 PM, Michal Kubecek wrote:
> On Tue, Dec 03, 2013 at 11:17:37AM -0500, Vlad Yasevich wrote:
>>> diff --git a/drivers/net/macvlan.c b/drivers/net/macvlan.c
>>> index acf9379..cfb9157 100644
>>> --- a/drivers/net/macvlan.c
>>> +++ b/drivers/net/macvlan.c
>>> @@ -820,13 +820,11 @@ int macvlan_common_newlink(struct net *src_net, struct net_device *dev,
>>>  	if (lowerdev == NULL)
>>>  		return -ENODEV;
>>>  
>>> -	/* When creating macvlans on top of other macvlans - use
>>> +	/* When creating macvlans or macvtaps on top of other macvlans - use
>>>  	 * the real device as the lowerdev.
>>>  	 */
>>> -	if (lowerdev->rtnl_link_ops == dev->rtnl_link_ops) {
>>> -		struct macvlan_dev *lowervlan = netdev_priv(lowerdev);
>>> -		lowerdev = lowervlan->lowerdev;
>>> -	}
>>> +	if (netif_is_macvlan(lowerdev))
>>> +		lowerdev = macvlan_dev_real_dev(lowerdev);
>>>  
>>>  	if (!tb[IFLA_MTU])
>>>  		dev->mtu = lowerdev->mtu;
>>>
>>
>> the other question is should this be done in a loop?  What happens if
>> you have nested namespaces?
> 
> Nested namespaces are not a problem, what would be a problem, would be
> having a macvlan (macvtap) device on top of another macvlan. But the
> purpose of this particular code is to prevent it and use the underlying
> "real" device instead. That's why unlike vlan_dev_real_dev(),
> macvlan_dev_real_dev() doesn't need to recurse.
> 
>                                                          Michal Kubecek
> 

Wait,  so you have a namespace that uses macvlan to access the net.
That macvlan is configured on top of another macvlan, so you need to
get to the lower level device.  I understand that.  What I am asking
is that what happens if you have a namespace within a namespace with
the same network access restrictions.  The code as is, will think that
the first level macvlan is the real device.  Is this setup practical...

The reason I ask is that there is nothing preventing it, and it would
break just the same as your setup did.

-vlad